#include <oslink.h>
#include "CServerPluginPending.h"

CServerPluginPending g_ServerPluginPending;
IVEngineServer *g_Engine = NULL;
IServerGameClients *g_ServerClients = NULL;

PLUGIN_EXPOSE(CServerPluginPending, g_ServerPluginPending);

SH_DECL_HOOK2_void(IServerGameClients, ClientActive, SH_NOATTRIB, 0, edict_t *, bool);

#define	FIND_IFACE(func, assn_var, num_var, name, type) \
	do \
	{ \
		if ((assn_var = (type)((ismm->func())(name, NULL))) != NULL || num_var >= 999) \
			break; \
	} \
	while (num_var = ismm->FormatIface(name, sizeof(name) - 1));

void CServerPluginPending_ClientActive(edict_t *entity, bool bLoadGame)
{
	if (!entity)
		RETURN_META(MRES_IGNORED);

	int userid = g_Engine->GetPlayerUserId(entity);
	if (userid < 1)
		RETURN_META(MRES_IGNORED);

	const char *steamid = g_Engine->GetPlayerNetworkIDString(entity);
	if (!steamid || !Q_stristr(steamid, "PENDING"))
		RETURN_META(MRES_IGNORED);

	/* "kickid " = 7, kick message = 40, \0 = 1, + 1 for int length thing */
	int length = ((int) log10((float) userid)) + 49;
	char *command = (char *) malloc(length);
	Q_snprintf(command, length, "kickid %d Network ID didn't validate. Reconnect.\n", userid);
	g_Engine->ServerCommand(command);
	free(command);

	RETURN_META(MRES_HANDLED);
}

bool CServerPluginPending::Load(PluginId id, ISmmAPI *ismm, char *error, size_t maxlen, bool late)
{
	PLUGIN_SAVEVARS();

	char buffer[255];
	int number = 0;

	Q_strcpy(buffer, INTERFACEVERSION_VENGINESERVER);
	FIND_IFACE(engineFactory, g_Engine, number, buffer, IVEngineServer *);
	if (!g_Engine)
	{
		Q_snprintf(error, maxlen, "Could not find interface %s", INTERFACEVERSION_VENGINESERVER);
		return false;
	}

	Q_strcpy(buffer, INTERFACEVERSION_SERVERGAMECLIENTS);
	FIND_IFACE(serverFactory, g_ServerClients, number, buffer, IServerGameClients *);
	if (!g_ServerClients)
	{
		Q_snprintf(error, maxlen, "Could not find interface %s", INTERFACEVERSION_SERVERGAMECLIENTS);
		return false;
	}

	SH_ADD_HOOK_STATICFUNC(IServerGameClients, ClientActive, g_ServerClients, CServerPluginPending_ClientActive, true);

	return true;
}

bool CServerPluginPending::Unload(char *error, size_t maxlen)
{
	SH_REMOVE_HOOK_STATICFUNC(IServerGameClients, ClientActive, g_ServerClients, CServerPluginPending_ClientActive, true);

	return true;
}
